<?php
/**
* @Copyright Copyright (C) 2010- boncko
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html,
**/

defined( '_JEXEC' ) or die( 'Restricted access' );
require_once('BonckoWall/Rss.php');
//error_reporting(E_ALL & ~E_NOTICE );
//error_reporting(E_ALL);

class plgContentplgBonckoWall extends JPlugin{
  var $width = 200;
  var $height =  0;
  var $rootfolder = 'images/stories';
  var $resetRss= 1;
  var $logo='';
  var $pathAbs = '';
  var $pathSite ='';
  var $docRoor='';
  var $rssFileNamePrefix='bonckowall';
  var $rssFileName='';
  var $playIco='/plugins/content/plgBonckoWall/BonckoWall/images/play.jpg';
  var $sortorder=0;
  var $debug=FALSE;
  var $cssClass="bonckowall";
  var $imgLink=0;
  var $fuuscreen=TRUE;
  var $backgroundColor;
  var $backgroundImage ;
  var $descriptionHeight;
  var $showDescription;
  var $showTitles;
  var $glowColor;
  var $numRows;
  var $numColl;
  var $showChrome;
  var $showReflections;
  var $showEmbed;
  var $showSearch;
  var $showNavArrows;
  var $style;
  var $imageURL;
  var $targetURL;
  var $itemGUID;
  var $align;
  var $feedExt;
  var $param; 
  var $source;
  var $fkey;  
  var $fvalue;
  var $fvalue2;  
  var $pkey;   
  var $pvalue; 
  var $pvalue2;
  var $disallowedPrefix=array("BNCKTMB");
  var $disallowedReg="";
  var $showLink;
  var $link;
  var $cellBorder;
  var $cellWidth;
  var $cellHeight;
  var $cellSpacingX;
  var $cellSpacingY;
  var $showItemEmbed;
  var $browseChache;
  var $linkTarget;
  var $crossdomain;
  var $introText=1;
  var $inIntro=1;
  var $admin=false;
    
  function plgContentplgBonckoWall( &$subject,$params )
  {
    parent::__construct( $subject ,$params);
    $this->pathAbs = JPATH_ROOT;
	$this->pathSite = JURI :: base();
    if(strpos($this->pathSite,"/administrator")){
		#NON DEVE GIRARE COME AMMINISTRATORE PERCHE INUTILE
		$this->admin=true;
		return;
	}
    //$this->_plugin = JPluginHelper::getPlugin( 'content', 'plgBonckoWall' );
	$script=getenv("SCRIPT_NAME");
    if($script!='/index.php'&& $script!='/index2.php'){
      $localpath=substr(getenv("SCRIPT_NAME"),0,strrpos($script,"/index.php")); 
      $this->docRoot=substr($this->pathAbs,0,strrpos($this->pathAbs,$localpath));
    }
    else {
      $this->docRoot=$this->pathAbs;
    }
    if(substr($this->pathSite, -1)=="/") $this->pathSite = substr($this->pathSite, 0, -1);
    if(substr($this->pathAbs, -1)=="/") $this->pathSite = substr($this->pathSite, 0, -1);
    if(substr($this->rootfolder, -1)=="/")$this->rootfolder= substr($this->rootfolder,0, -1);
    
    $this->debug      =($this->params->get('debug','0')=='1');
    $this->rootfolder = $this->params->get('rootfolder','');
    $this->resetRss   = $this->params->get('resetRss',1);
    $this->sortorder  = $this->params->get('sortorder',0);
    $this->feedExt   .= $this->params->get('feedExt','rss');
    $this->cssClass  .= $this->params->get('cssClassSuffix','');
    $this->crossdomain  .= $this->params->get('crossdomain',1);
    $this->playIco    = $this->params->get('playico','/plugins/content/plgBonckoWall/BonckoWall/images/play.jpg');
    $mystr  =strtoupper($this->params->get('prefix','THUMB'));
	$arr=explode(",",$mystr);
	$this->disallowedPrefix=array_merge($this->disallowedPrefix,$arr);
	$this->disallowedReg="/(".implode("|", $this->disallowedPrefix).")/i";
    if ($this->debug) error_reporting(E_ALL); 
    $this->_debug("<h3> <br/>Debug Mode set to On in plugin configuration </h3>");
    $this->_debug("<br/>
    PlgCfg rootfolder     ".$this->rootfolder."<br/>
    PlgCfg resetRss       ".$this->resetRss."<br/>
    PlgCfg sortorder      ".$this->sortorder."<br/>
    PlgCfg playIco        ".$this->playIco."<br/>
    PlgCfg feedExt        ".$this->feedExt."<br/>    
    PlgCfg cssClassSuffix ".$this->cssClass."<br/>
    PlgCfg crossdomain    ".$this->crossdomain);
  }
  
  function _debug($testo){
  	if ($this->debug) echo $testo.'<br />';
  	
  }
  
  function crossDomainCreate($crossdomain){
  	if($this->crossdomain == 0 ) return;
  	if (!file_exists($crossdomain)){
    try{
       $file_handle = fopen($crossdomain, "w");
       if (!$file_handle) {
          $this->_debug("File ".$crossdomain." creation error<br/>");
       }
       fwrite($file_handle,'<?xml version="1.0"?>
  <!DOCTYPE cross-domain-policy SYSTEM  "http://www.macromedia.com/xml/dtds/cross-domain-policy.dtd">
  <cross-domain-policy>
    <allow-access-from domain="*.cooliris.com" secure="false" />
  </cross-domain-policy>');
       fclose($file_handle);
       $this->_debug("File ".$crossdomain." creato");
    }catch(Exception $e)
    {
      $this->_debug('Message: ' .$e->getMessage()."<br/>");
    }
   } 
  
  }
  
  function rssCreateLocale($_temp){
  	$_params = explode("|",$_temp);
    $this->rssFileName=$this->rssFileNamePrefix.md5($_temp).".".$this->feedExt;
    $rssPath=$this->pathAbs.$this->rootfolder.'/'.$this->rssFileName;
    $rssUrl =$this->pathSite.$this->rootfolder.'/'.$this->rssFileName;
    $this->_debug("
    rssFileName=".$this->rssFileName."<br/>
    rssPath    =".$rssPath."<br/>
    rssUrl     =".$rssUrl);
    
    $rss= new rssCIItemList("","",$this->playIco,$this->logo,"",$this->showLink,$this->debug,$this->disallowedReg,$this->link);
    foreach($_params as $dir){
      $imagesDir= $this->rootfolder.$dir; 
      if(substr($imagesDir, -1)=="/") $imagesDir= substr($imagesDir, 0, -1);
      if ($this->imgLink) $imgUrl=$this->pathSite.$imagesDir;
      else $imgUrl=$this->pathSite.$imagesDir;
      $imgDir=$this->pathAbs.$imagesDir;
      if (!is_dir($imgDir)){
        return "<br/>Dir: ".$imgDir." inesistente<br/>"; 
      }
      $rssTmp= new rssCIItemList($imgDir,$imgUrl,$this->playIco,$this->logo,"",$this->showLink,$this->debug,$this->disallowedReg,$this->link);
      $rss->append($rssTmp);
    }
    if($rss->count() < 1){
      return "<br/>Le Dir: ".$_temp."non contengono immagini<br/>";
    }
    else{
      switch ($this->sortorder) {
        case 0:
          $this->_debug("nessun ordine");
          break;
        case 1:
          $rss->sortByItemName();
          $this->_debug("ordinati per nome");
          break;
        case 2:
          $rss->sortByItemPath();
          $this->_debug("ordinati per nome e percorso<br/>");
          break;
        case 3:
          $rss->sortByItemDate();
          $this->_debug("ordinati per data");
          break;
        case 4:
          $rss->sortByItemDateReverse();
          $this->_debug("ordinati per data inversa");
          break;
        case 5:
          $rss->sortRandom();
          $this->_debug("ordinati per nome inverso");
          break;   
          
        case 6:
          $rss->sortByItemNameReverse();
          $this->_debug("ordinati per nome inverso");
          break;   
               
        break;

      }
      if (!file_exists($rssPath) || $this->resetRss) {
        //creazione file rss
        try{
          $file_handle = fopen($rssPath, "wb");
          if (!$file_handle) {
            echo "File ".$rssPath." creation error";
          }
          $this->_debug($rss->__toString());
          fwrite($file_handle, utf8_encode($rss->__toString()));
          fclose($file_handle);
          $this->_debug("File ".$rssPath." creato");
        }catch(Exception $e)
          {
            echo 'Message: ' .$e->getMessage();
          }
      }
    }
    $rssData=new rssFile($rss,$rssPath,$rssUrl);
    return $rssData;
  }
  
  function rssCreateFlickr(){
   	$rssUrl="api://www.flickr.com/?";
  	if($this->fkey=="album") $rssUrl.="user=".$this->fvalue."%26album=".$this->fvalue2;
  	else $rssUrl.=$this->fkey."=".$this->fvalue;
  	return new rssFile(new rssCIItemList("","",$this->playIco,$this->logo,"",$this->showLink,$this->debug,$this->disallowedReg,$this->link),null,$rssUrl);
  }
  
  function rssCreatePicasa(){
        
  	$rssUrl="api://picasaweb.google.com/?";
  	if($this->pkey=="album") $rssUrl.="user=".$this->pvalue."%26album=".$this->pvalue2;
  	else $rssUrl.=$this->pkey."=".$this->pvalue;
  	return new rssFile(new rssCIItemList("","",$this->playIco,$this->logo,"",$this->showLink,$this->debug,$this->disallowedReg,$this->link),null,$rssUrl);
  }
  
  function onContentPrepare($context,&$row, &$params, $limitstart) {
	if($this->admin) return;
	if (!strpos($row->text,"bonckowall")) return;
    $regex='#{bonckowall(.*?)}(.*?){/bonckowall}#s';
    if (isset($row->readmore_link) || property_exists($row, $readmore_link)) {    
      $this->inIntro=!$row->readmore_link; 
    }    
    $row->text=preg_replace_callback($regex,array($this, 'bonckoWallReplacer'),$row->text);
  }

  function getInlineParameterString($name,$str,$default=''){
    if (preg_match('#'.$name.'="(.*?)"#', $str, $regs)) {
          $this->_debug("InLine ".$name." regs[1]=".$regs[1]);
          return $regs[1];
        }
        
        return $default;
  	}
  	
  function getInlineParameterBool($name,$str,$default=''){
    if (preg_match('#'.$name.'="(.*?)"#', $str, $regs)) {
          $this->_debug("InLine ".$name." regs[1]=".$regs[1]);
          return ($regs[1]=='1')?1:0;
        }
        return $default;
  	}  
  function getPluginParams(){
  	$this->width      = $this->params->get('width', 500);
    $this->height     = $this->params->get('height', 400);
    $this->imgLink    =($this->params->get('showimglink','0')=='1');
    $this->fullscreen =($this->params->get('fullscreen','0')=='1');
    $this->backgroundColor =$this->params->get('backgroundColor','#000000');
    $this->backgroundImage =$this->params->get('backgroundImage','');
    $this->targetURL       =$this->params->get('targetURL','');
    $this->imageURL        =$this->params->get('imageURL','');
    $this->descriptionHeight =$this->params->get('descriptionHeight','50');
    $this->descriptionHeight =$this->params->get('descriptionHeight','50');
    $this->glowColor         =$this->params->get('glowColor','#000000');
    $this->numRows         =$this->params->get('numRows','3');
    $this->numColl         =$this->params->get('numColl','5');
    $this->showChrome      =($this->params->get('showChrome','1')=='1')?'true':'false';
    $this->showDescription =($this->params->get('showDescription','1')=='1')?'true':'false';
    $this->showTitles      =($this->params->get('showTitles','1')=='1')?'true':'false';
    $this->showReflections =($this->params->get('showReflections','1')=='1')?'true':'false'; 
    $this->showEmbed       =($this->params->get('showEmbed','1')=='1')?'true':'false'; 
    $this->showSearch      =($this->params->get('showSearch','1')=='1')?'true':'false';      
    $this->showNavArrows   =($this->params->get('showNavArrows','1')=='1')?'true':'false';      
    $this->style           =$this->params->get('style','black');
    $this->align           =$this->params->get('align','center');
    $this->itemGUID        =$this->params->get('itemGUID','');
    $this->source          =$this->params->get('source','0');
    $this->fkey            =$this->params->get('fkey','0');
    $this->fvalue          =$this->params->get('fvalue','');
    $this->fvalue2          =$this->params->get('fvalue2','');
    $this->pkey            =$this->params->get('pkey','0');
    $this->pvalue          =$this->params->get('pvalue','');
    $this->pvalue2         =$this->params->get('pvalue2','');
    $this->showLink        =$this->params->get('showLink','1');
    $this->link            =$this->params->get('link','');
    $this->cellWidth       =$this->params->get('cellWidth','430');
    $this->cellHeight      =$this->params->get('cellHeight','300');
    $this->cellSpacingY    =$this->params->get('cellSpacingY','0.18');
    $this->cellSpacingX    =$this->params->get('cellSpacingX','0.18');
    $this->cellBorder      =$this->params->get('cellBorder','0');
    $this->showItemEmbed   =($this->params->get('showItemEmbed','1')=='1')?'true':'false';
    $this->linkTarget      =$this->params->get('linkTarget','_blank');
    $this->introText       =($this->params->get('introText','1')=='1')?true:false;
   
    $this->browseChache    =($this->params->get('browseChache','1')=='1')?'true':'false';
    if ($this->debug) error_reporting(E_ALL);
    $this->_debug("
    
    PlgCfg width             ".$this->width."<br/>
    PlgCfg height            ".$this->height."<br/>
    PlgCfg showimglink       ".$this->imgLink."<br/>
    PlgCfg fullscreen        ".$this->fullscreen."<br/>
    PlgCfg backgroundColor   ".$this->backgroundColor."<br/>
    PlgCfg backgroundImage   ".$this->backgroundImage."<br/>
    PlgCfg targetURL         ".$this->targetURL."<br/>
    PlgCfg imageURL          ".$this->imageURL."<br/>
    PlgCfg descriptionHeight ".$this->descriptionHeight."<br/> 
    PlgCfg glowColor         ".$this->glowColor."<br/> 
    PlgCfg numRows         ".$this->numRows."<br/> 
    PlgCfg numColl         ".$this->numColl."<br/> 
    PlgCfg showChrome      ".$this->showChrome."<br/> 
    PlgCfg showDescription ".$this->showDescription."<br/>
    PlgCfg showTitles      ".$this->showTitles."<br/>  
    PlgCfg showReflections ".$this->showReflections."<br/> 
    PlgCfg showEmbed       ".$this->showEmbed."<br/> 
    PlgCfg showSearch      ".$this->showSearch."<br/> 
    PlgCfg showNavArrows   ".$this->showNavArrows."<br/> 
    PlgCfg style           ".$this->style."<br/> 
    PlgCfg align           ".$this->align."<br/> 
    PlgCfg itemGUID        ".$this->itemGUID."<br/> 
    PlgCfg source          ".$this->source ."<br/>   
    PlgCfg fkey            ".$this->fkey  ."<br/>    
    PlgCfg fvalue          ".$this->fvalue ."<br/>   
    PlgCfg pkey            ".$this->pkey   ."<br/>   
    PlgCfg pvalue          ".$this->pvalue ."<br/>   
    PlgCfg pvalue2         ".$this->pvalue2 ."<br/>  
    PlgCfg showLink        ".$this->showLink ."<br/>
    PlgCfg Link            ".$this->link."<br/>    
    PlgCfg cellWidth       ".$this->cellWidth."<br/>  
    PlgCfg cellHeight      ".$this->cellHeight."<br/>  
    PlgCfg cellSpacingX    ".$this->cellSpacingX."<br/>  
    PlgCfg cellSpacingY    ".$this->cellSpacingY."<br/>  
    PlgCfg cellBorder      ".$this->cellBorder."<br/>  
    PlgCfg showItemEmbed   ".$this->showItemEmbed."<br/>
    PlgCfg linkTarget      ".$this->linkTarget."<br/>
    PlgCfg browseChache    ".$this->browseChache."<br/>
    PlgCfg introText       ".$this->introText."<br/>
    introText
    ");
  }
  
  function getInlineParams($str){
  $this->_debug("InLine Params ".$str."<br/>");
    $this->width=$this->getInlineParameterString("width",$str,$this->width);
    $this->height=$this->getInlineParameterString("height",$str,$this->height);
    $this->fullscreen=$this->getInlineParameterBool("fullscreen",$str,$this->fullscreen);
    $this->imgLink=$this->getInlineParameterString("imglink",$str,$this->imgLink);
    $this->backgroundColor=$this->getInlineParameterString("backgroundColor",$str,$this->backgroundColor);
    $this->backgroundImage=$this->getInlineParameterString("backgroundImage",$str,$this->backgroundImage);    
    $this->targetURL=$this->getInlineParameterString("targetURL",$str,$this->targetURL);        
    $this->imageURL=$this->getInlineParameterString("imageURL",$str,$this->imageURL);        
    $this->descriptionHeight=$this->getInlineParameterString("descriptionHeight",$str,$this->descriptionHeight);        
    $this->glowColor=$this->getInlineParameterString("glowColor",$str,$this->glowColor);        
    $this->showChrome=$this->getInlineParameterString("showChrome",$str,$this->showChrome);        
    $this->showDescription=$this->getInlineParameterString("showDescription",$str,$this->showDescription);        
    $this->showTitles=$this->getInlineParameterString("showTitles",$str,$this->showTitles);
    $this->showReflections=$this->getInlineParameterString("showReflections",$str,$this->showReflections);        
    $this->showEmbed=$this->getInlineParameterString("showEmbed",$str,$this->showEmbed);        
    $this->showSearch=$this->getInlineParameterString("showSearch",$str,$this->showSearch);        
    $this->showNavArrows=$this->getInlineParameterString("showNavArrows",$str,$this->showNavArrows);        
    $this->style=$this->getInlineParameterString("style",$str,$this->style);        
    $this->numRows=$this->getInlineParameterString("numRows",$str,$this->numRows);        
    $this->numColl=$this->getInlineParameterString("numColl",$str,$this->numColl);            
    $this->align=$this->getInlineParameterString("align",$str,$this->align);        
    $this->itemGUID=$this->getInlineParameterString("itemGUID",$str,$this->itemGUID);        
    $this->source   =$this->getInlineParameterString("source",$str,$this->source  );
    $this->fkey     =$this->getInlineParameterString("fkey",$str,$this->fkey    );
    $this->fvalue   =$this->getInlineParameterString("fvalue",$str,$this->fvalue  );
    $this->fvalue2   =$this->getInlineParameterString("fvalue2",$str,$this->fvalue2  );
    $this->pkey     =$this->getInlineParameterString("pkey",$str,$this->pkey    );
    $this->pvalue   =$this->getInlineParameterString("pvalue",$str,$this->pvalue  );
    $this->pvalue2  =$this->getInlineParameterString("pvalue2",$str,$this->pvalue2 );
    $this->showLink =$this->getInlineParameterString("showLink",$str,$this->showLink);
    $this->link     =$this->getInlineParameterString("link",$str,$this->link);
    $this->cellWidth    =$this->getInlineParameterString("cellWidth",$str,$this->cellWidth); 
    $this->cellHeight   =$this->getInlineParameterString("cellHeight",$str,$this->cellHeight);
    $this->cellSpacingY =$this->getInlineParameterString("cellSpacingY",$str,$this->cellSpacingY);
    $this->cellSpacingX =$this->getInlineParameterString("cellSpacingX",$str,$this->cellSpacingX);
    $this->cellBorder =$this->getInlineParameterString("cellBorder",$str,$this->cellBorder);
    $this->showItemEmbed=$this->getInlineParameterString("showItemEmbed",$str,$this->showItemEmbed);
    $this->linkTarget=$this->getInlineParameterString("linkTarget",$str,$this->linkTarget);
    $this->browseChache=$this->getInlineParameterBool("browseChache",$str,$this->browseChache);
    $this->introText=$this->getInlineParameterBool("introText",$str,$this->introText);
    
  	}
  	
  function bonckoWallReplacer(&$matches){
 
    $this->getPluginParams();
    $this->getInlineParams(@$matches[1]);
    if($this->inIntro && !$this->introText){
    	 
    	return "";
    	
    }
    
    global $mainframe;
    $this->_debug($this->debug,"
    match[0]=".@$matches[0]."<br/>
    match[1]=".@$matches[1]."<br/>
    match[2]=".@$matches[2]);
    
    $crossdomain=$this->pathAbs.'/crossdomain.xml';
    $this->crossDomainCreate($crossdomain);
    $crossdomain=$this->docRoot.'/crossdomain.xml';
    $this->crossDomainCreate($crossdomain);

    $_temp=@$matches[2];
    if($this->source==0)  $rssData=$this->rssCreateLocale($_temp);
    if($this->source==1)  $rssData=$this->rssCreateFlickr();
    if($this->source==2)  $rssData=$this->rssCreatePicasa();

      $feed='feed='.$rssData->getRssURL().
       '&backgroundColor='.$this->backgroundColor.
       '&descriptionHeight='.$this->descriptionHeight.
       '&glowColor='.$this->glowColor.
       '&numRows='.$this->numRows.
       '&numColsForDefaultZoom='.$this->numColl.
       '&showChrome='.$this->showChrome.
       '&showDescription='.$this->showDescription.
       '&showTitles='.$this->showTitles.
       '&showReflections='.$this->showReflections.
       '&showEmbed='.$this->showEmbed.
       '&showItemEmbed='.$this->showItemEmbed.
       '&showSearch='.$this->showSearch.
       '&showNavArrows='.$this->showNavArrows.
       '&cellWidth='.$this->cellWidth.
       '&cellHeight='.$this->cellHeight.
       '&cellSpacingX='.$this->cellSpacingX.
       '&cellSpacingY='.$this->cellSpacingY.
       '&cellBorder='.$this->cellBorder. 
       '&linkTarget='.$this->linkTarget ;
       $feed.=($this->style!='none')?'&style='.$this->style:"";
       $feed.=($this->backgroundImage!='')?'&backgroundImage='.$this->backgroundImage:"";
       $feed.=($this->itemGUID > 0 && $this->itemGUID < $rssData->getRss()->count()+1)?'&itemGUID='.$rssData->getRss()->offsetGet($this->itemGUID-1)->getGuid():"";
       $feed.=($this->imageURL!="" && $this->targetURL!="")?'&customButton='.$this->imageURL.','.$this->targetURL:"";
       $feed.=($this->browseChache)?"&nocache=YES":'&nocache='.rand();
       $feed.='&tilt=3';
      $bonckoWall='
       <!-- added by bonckowall start -->
       <div id="bonckowall" style="text-align:'.$this->align.';">
       <object height="'.$this->height.'" width="'.$this->width.'" type="application/x-shockwave-flash" data="http://apps.cooliris.com/embed/cooliris.swf" id="o" style="visibility: visible;">
         <param name="movie" value="http://apps.cooliris.com/embed/cooliris.swf" />
         <param name="allowfullscreen" value="true">
         <param name="allowscriptaccess" value="always">
         <param name="bgcolor" value="'.$this->backgroundColor.'">
         <param name="wmode" value="opaque">
         <param name="flashvars" value="'.$feed.'" />
         <embed type="application/x-shockwave-flash"
          src="http://apps.cooliris.com/embed/cooliris.swf"
          flashvars="'.$feed.'"
          width="'.$this->width.'" 
          height="'.$this->height.'"
          allowFullScreen="true"
          allowScriptAccess="always">
    </embed>
         
       </object>       
      </div>
      <!-- added by bonckowall end -->';
      return $bonckoWall;
    
}

}

?>